import { ElementRef } from "@angular/core";
import { ValueField } from "../value-field";
import { AutoCompleteFieldEntry } from "./auto-complete-field-entry";
import { IForm } from "../../../pathinterface";
import { TranslationService } from "../../../service/translation.service";
import { PathService } from "../../../service/path.service";
export declare class AutoCompleteComponent {
    field: AutoCompleteField;
    private _elementRef;
    constructor(myElement: ElementRef);
    handleClick(event: any): void;
}
export declare class AutoCompleteField extends ValueField<string> {
    protected form: IForm;
    protected translationService: TranslationService;
    protected pathService: PathService;
    private _query;
    private _filteredList;
    private _data;
    private _dataLoaded;
    private _wordSearchEnabled;
    private _valueSet;
    private _detailForm;
    private _keyType;
    private _url;
    constructor(form: IForm, translationService: TranslationService, pathService: PathService);
    isReadonly(): boolean;
    filter(query: string, event: any): void;
    select(item: AutoCompleteFieldEntry): void;
    focusLost(): void;
    setValue(value: string): void;
    load(): void;
    getDetailButtonName(): string;
    showDetailForm(): void;
    clearFilteredList(): void;
    private resetDisplay(value);
    query: AutoCompleteFieldEntry;
    data: AutoCompleteFieldEntry[];
    readonly filteredList: AutoCompleteFieldEntry[];
    wordSearchEnabled: boolean;
    readonly valueSet: boolean;
    dataLoaded: boolean;
    detailForm: string;
    url: string;
}
