import { AfterViewInit } from "@angular/core";
import { PathService } from "../service/path.service";
import { IForm, IPathApp, IFormHandler, IFormBean } from "../pathinterface";
import { FormField } from "./field/form-field";
import { Key } from "../page/element/page-element";
import { FormFunction } from "./form-function";
export declare class FormComponent implements AfterViewInit {
    form: Form;
    onSubmit(): void;
    ngAfterViewInit(): void;
}
export declare class Form implements IForm {
    private pathService;
    private app;
    private _key;
    private _title;
    private _fields;
    private _rows;
    private _handler;
    private _url;
    private _bean;
    private _formFunction;
    private _headerVisible;
    private _footerVisible;
    private _borderStyle;
    constructor(pathService: PathService, app: IPathApp);
    getApp(): IPathApp;
    getKey(): Key;
    key: Key;
    readonly rows: FormRow[];
    title: string;
    getFields(): FormField[];
    fields: FormField[];
    handler: IFormHandler;
    url: string;
    bean: IFormBean;
    formFunction: FormFunction;
    headerVisible: boolean;
    footerVisible: boolean;
    borderStyle: BorderStyle;
    fromJson(modelForm: any): void;
    updateRows(): void;
    private calculateFieldRow(field, currentFormRow, rows);
    close(save: boolean, remove: boolean): void;
    onKey(event: any): void;
}
export declare class FormRow {
    private _fields;
    fields: FormField[];
    getWidth(): number;
    isVisible(): boolean;
}
export declare enum BorderStyle {
    None = 1,
    Shadow = 2,
}
