import { IListHandler, IList, IButtonHandler, IPathApp, IButton } from "../../../pathinterface";
import { PathService } from "../../../service/path.service";
import { AfterViewInit } from "@angular/core";
import { PageElement } from "../page-element";
import { TranslationService } from "../../../service/translation.service";
import { Button } from "../button/button.component";
export declare class ListComponent implements AfterViewInit {
    list: List;
    ngAfterViewInit(): void;
}
export declare class List extends PageElement implements IList {
    private pathService;
    private translationService;
    private _buttons;
    private _search;
    private _limit;
    private _searchRequired;
    private _searchRequest;
    private _searchLabel;
    private _searchInputLabel;
    private _searchText;
    private _searchTextChanged;
    private _handler;
    private _buttonHandler;
    private _icon;
    private _color;
    private _form;
    private _formHandler;
    private _page;
    private _mockData;
    private _url;
    constructor(app: IPathApp, pathService: PathService, translationService: TranslationService);
    getContent(): IButton[];
    refresh(searchText: string, afterRefreshHandler: () => void): void;
    private findButton(key, buttons);
    filterChanged(text: string): void;
    filter(): void;
    private setSearchResultsCountMessage();
    private visibleItemSize();
    buttons: Button[];
    search: boolean;
    handler: IListHandler;
    buttonHandler: IButtonHandler;
    icon: string;
    color: string;
    form: string;
    formHandler: string;
    page: string;
    mockData: any;
    url: string;
    limit: number;
    readonly searchRequired: boolean;
    readonly searchRequest: boolean;
    searchText: string;
    searchLabel: string;
    searchInputLabel: string;
    fromJson(modelElement: any): void;
}
