import * as path from "./path";
import { Key } from "./page/element/page-element";
import { FormFunction } from "./form/form-function";
import { TranslationService } from "./service/translation.service";
import { Type } from "@angular/core";
import { CustomPageElement } from "./page/element/custom/custom-container.component";
export declare abstract class PathAppComponent implements path.IPathApp {
    private pathService;
    private translationService;
    private _pageStack;
    private _formStack;
    private _userId;
    private _texts;
    private _version;
    show: boolean;
    constructor(pathService: path.PathService, translationService: TranslationService);
    protected abstract getStartPage(): string;
    protected getApplicationLogo(): string;
    protected abstract getOwnUserForm(): string;
    protected abstract getGuiModel(): any;
    protected abstract getBeans(): any;
    protected abstract getHandlers(): any;
    abstract getBackendUrl(): string;
    protected abstract getFrontendVersion(): string;
    isLoading(): boolean;
    private loadApplicationTexts();
    getUserId(): string;
    login(event: any, userId: string, password: string): void;
    logout(): void;
    showUserForm(): void;
    closeCurrentForm(): void;
    refreshCurrentPage(): void;
    private refreshPageStack(index, clearSearch, afterRefreshHandler);
    navigateBack(clearSearch?: boolean): void;
    navigateToPage(pageNumber: number): void;
    yesNo(text: string, yesHandler: () => void, noHandler: () => void): void;
    protected getCustomComponentClass(componentType: string): Type<CustomPageElement>;
    setCurrentPage(pageId: string, parentPageElement: path.PageElement): void;
    private addPageElement(page, modelElement, parentPageElement);
    setCurrentForm(formId: string, key: Key, handler: string, parentPageElement: path.IPageElement): void;
    private getModelForm(formId);
    createForm(formId: string, key: Key, handler: string, formFunction: FormFunction, parentPageElement: path.IPageElement): path.Form;
    private createFormField(modelFormField, form, parentPageElement);
    toggleCollapse(): void;
}
