import { TranslationService } from "./translation.service";
import { HttpClient } from "@angular/common/http";
export declare class PathService {
    private http;
    private translationService;
    private _requestCount;
    private _alertStack;
    constructor(http: HttpClient, translationService: TranslationService);
    isLoading(): boolean;
    private showLoading();
    hideLoading(): void;
    serverGet(server: string, url: string, processor: (data: any) => any, errorHandler: (err: any) => any): void;
    serverPost(server: string, url: string, data: any, processor: (data: any) => any, errorHandler: (err: any) => any): void;
    serverPut(server: string, url: string, data: any, processor: (data: any) => any): void;
    serverDelete(server: string, url: string, processor: (data: any) => any): void;
    private handleError(err);
    private appendHeaders();
    getAlerts(): Alert[];
    addAlert(title: string, text: string): void;
    clearAlert(id: number): void;
}
export declare class Alert {
    private _title;
    private _text;
    private _id;
    title: string;
    text: string;
    readonly id: number;
}
